=== debian/changelog ===
cgreen (1.3.0-2) unstable; urgency=medium

  [ Alvin Chen ]
  * Fix endian issue of tests.
    - is_equal_to_* is not able to handle compare variable which length is
      longer than 1 byte on big-endian architecture. However it is still
      capable to work well while comparing on a one-byte basis.
      (Closes: #972220)
  * Disable fixfilepath in debian/rules
    - it triggers build failures when enabled. Thanks to Vagrant Cascadian
      <vagrant@reproducible-builds.org> (Closes: #972304)

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 12 Nov 2020 13:21:15 +0800

cgreen (1.3.0-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat to 13
  * Update install file
  * Remove patch files which are fixed by upstream
  * Add a patch file to fix file references package build path

 -- Alvin Chen <sonoma001@gmail.com>  Tue, 11 Aug 2020 01:38:38 -0400
