=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
# Disable fixfilepath as it triggers build failures.
export DEB_BUILD_MAINT_OPTIONS := hardening=+all reproducible=-fixfilepath
export DEB_CFLAGS_MAINT_APPEND := -Wall -D_FORTIFY_SOURCE=2 -O1
SRC	:= $(CURDIR)
BUILD	:= $(SRC)/build
TARGET	:= $(SRC)/debian/tmp

%:
	dh $@

override_dh_auto_test:
	LD_LIBRARY_PATH="$(BUILD)/src/" dh_auto_test

override_dh_auto_configure:
	[ -d $(BUILD) ] || mkdir $(BUILD)
	cd $(BUILD) && cmake $(CURDIR) -DCMAKE_INSTALL_PREFIX="/usr" \
		-DCMAKE_SKIP_RPATH=ON \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DLIB_INSTALL_DIR=/usr/lib \
		-DCGREEN_WITH_PDF_DOCS:bool=TRUE
	touch configure-stamp


override_dh_clean:
	rm -f configure-stamp build-stamp gitrevision.h
	rm -rf $(BUILD)
	dh_clean
